%define name	snare
%define version 0.9
%define release 4rph
%define kver	%(eval echo `uname -r `)

%define build_90 1

Summary:	An intrusion detection tool for GNOME
Name:		%{name}
Version:	%{version}
Release:	%{release}
Copyright:	GPL
Group:		Applications/System
URL:		http://www.intersectalliance.com/
Source:		http://www.intersectalliance.com/snare/%{name}-%{version}.tar.gz
Source1:	http://www.intersectalliance.com/snare-core/%{name}-core-%{version}.tar.gz
Source2:	snare.logrotate
Source3:	snare.init
Source4:	snare.audit.conf
Patch:		snare-0.9-core-Makefile.patch.bz2
BuildRoot:	%{_tmppath}/%{name}-%{version}
Requires:	gtk+ >= 1.2.7, gnome-libs >= 1.2.0, %{name}-core = %{version}
BuildRequires:	libgnome-devel, libORBit-devel, bison, kernel-source, automake

%description
The Graphical User Interface component of the System iNtrusion Analysis and
Reporting Environment (SNARE).


%package core
Summary:	Kernel module for SNARE intrusion detection tool
Group:		System Environment/Daemons
Requires:	kernel = %{kver}

%description core
The Audit daemon and module components of the System iNtrusion Analysis and
Reporting Environment (SNARE).  Built for Mandrake Linux kernel version
%{kver}.


%prep
%setup -q
%setup -q -D -T -a1

%patch -p0 -b .Makefile

%build
#CFLAGS="$RPM_OPT_FLAGS"
# force a reconfigure if config.cache exists
[ -f config.cache ] && rm config.cache

# Really bad way to determine which automake we have installed
%if %{build_90}
  if [ -d %{_datadir}/automake-1.4 ]; then
    AUTODIR=%{_datadir}/automake-1.4
  fi
  if [ -d %{_datadir}/automake-1.6 ]; then
    AUTODIR=%{_datadir}/automake-1.6;
  fi
  (cd $RPM_BUILD_DIR/%{name}-%{version}
  ln -sf $AUTODIR/missing .
  ln -sf $AUTODIR/install-sh .
  ln -sf $AUTODIR/mkinstalldirs .
  )
%endif


%configure
%make

cd %{name}-core-%{version}
%make
cd ..


%install
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
mkdir -p %{buildroot}{%{_bindir},%{_sbindir},%{_datadir}/{pixmaps,applnk/System}}
mkdir -p %{buildroot}%{_datadir}/gnome/{apps/System,ximian/Programs/Utilities}
mkdir -p %{buildroot}%{_initrddir}
mkdir -p %{buildroot}/var/log/audit

install -m 644 snare-icon.png %{buildroot}%{_datadir}/pixmaps
install -m 644 snare-logo.png %{buildroot}%{_datadir}/pixmaps
install -m 644 snare.desktop %{buildroot}%{_datadir}/gnome/apps/System
install -m 644 snare.desktop %{buildroot}%{_datadir}/gnome/ximian/Programs/Utilities
install -m 644 Snare.kdelnk %{buildroot}%{_datadir}/applnk/System

%makeinstall

mkdir -p %{buildroot}%{_sysconfdir}/pam.d
cat > %{buildroot}%{_sysconfdir}/pam.d/snare <<EOF
auth       sufficient   /lib/security/pam_rootok.so
auth       required     /lib/security/pam_stack.so service=system-auth
session    optional     /lib/security/pam_xauth.so
account    required     /lib/security/pam_permit.so
EOF

mkdir -p %{buildroot}%{_sysconfdir}/security/console.apps
cat > %{buildroot}%{_sysconfdir}/security/console.apps/snare <<EOF
USER=root
FALLBACK=true
PROGRAM=/usr/sbin/snare
SESSION=true
EOF

cd %{name}-core-%{version}
%makeinstall initdir=%{buildroot}%{_initrddir} \
  confdir=%{buildroot}%{_sysconfdir}/audit \
  moddir=%{buildroot}/lib/modules/%{kver}/audit
#make prefix=%{buildroot}%{_prefix} install
cd ..

# make stuff clean
mv %{buildroot}%{_bindir}/{snare,auditd} %{buildroot}%{_sbindir}
ln -s %{_bindir}/consolehelper %{buildroot}/%{_bindir}/snare

mkdir -p %{buildroot}%{_sysconfdir}/logrotate.d
install -m 644 %{SOURCE2} %{buildroot}%{_sysconfdir}/logrotate.d/audit

# replace with a chkconfig-aware audit initscript
cp -f %{SOURCE3} %{buildroot}%{_initrddir}/audit

# make menu entry
mkdir -p %{buildroot}%{_menudir}
cat > %{buildroot}%{_menudir}/snare <<EOF
?package(snare): \
command="%{_bindir}/snare" \
title="SNARE" \
longtitle="System iNtrusion Analysis and Reporting Environment" \
needs="x11" \
section="Applications/Monitoring" \
icon="snare_icon.png"
EOF

# install a customized audit.conf
rm -f %{buildroot}%{_sysconfdir}/audit/audit.conf
install -m 600 %{SOURCE4} %{buildroot}%{_sysconfdir}/audit/audit.conf


%post
%update_menus


%postun
%clean_menus


%post core
%_post_service audit


%preun core
%_preun_service audit


%clean
[ -n "%{buildroot}" -a "%{buildroot}" != / ] && rm -rf %{buildroot}
rm -rf $RPM_BUILD_DIR/%{name}-%{version}


%files
%defattr(-,root,root)
%doc README ChangeLog AUTHORS COPYING snare-core-%{version}/doc/*
%attr(755,root,root) %{_sbindir}/snare
%{_bindir}/snare
%{_datadir}/gnome/apps/System/snare.desktop
%{_datadir}/gnome/ximian/Programs/Utilities/snare.desktop
%{_datadir}/pixmaps/*
%{_menudir}/snare
%config(noreplace) %{_sysconfdir}/pam.d/snare
%config(noreplace) %{_sysconfdir}/security/console.apps/snare

%files core
%defattr(-,root,root)
%doc README ChangeLog AUTHORS TODO COPYING CREDITS doc
%attr(755,root,root) %{_sbindir}/auditd
%attr(644,root,root) /lib/modules/*/audit/auditmodule.o
%attr(755,root,root) %{_initrddir}/audit
%config(noreplace) %{_sysconfdir}/audit/audit.conf
%config(noreplace) %{_sysconfdir}/logrotate.d/audit
%dir /var/log/audit


%changelog
* Fri Aug 16 2002 Vincent Danen <vdanen@mandrakesoft.com> 0.9-4rph
- try to make logrotate a little smarter and hopefully prevent crashes by
  not rotating the log while the daemon is still running
- include html doc
- menu entry
- use system-auth for pam
- use a slightly customized audit.conf with some extra objectives and a
  little less verbosity

* Thu Aug 15 2002 Vincent Danen <vdanen@mandrakesoft.com> 0.9-3rph
- evaluate the kernel we're building against at compile time so a --rebuild
  will work regardless of the kernel installed
- use build_90 because we have to monkey around to figure out which automake
  is installed so we can recreate the symlinks properly

* Fri Jul 05 2002 Vincent Danen <vdanen@mandrakesoft.com> 0.9-2rph
- add a logrotate entry
- new audit initscript that is chkconfig aware

* Thu Jul 04 2002 Vincent Danen <vdanen@mandrakesoft.com> 0.9-1rph
- first rpmhelp.net version
- patch snare-core Makefile so it installs properly
- build for 2.4.18-8.1mdk

